#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_cx;
uniform float u_cy;
uniform float u_hx;
uniform float u_hy;
uniform float u_gmax;
uniform float u_gmin;

vec4 gradient(vec4 texCo, float m_s)
{   
    vec4 co = vec4(0.0);
    if (m_s < u_gmin)
        co += texCo * v_fragmentColor;
    else if (m_s >= u_gmax){
        co += vec4(0.0);
    }else{
        float mask = smoothstep(0.0, 1.0, (u_gmax - m_s) / (u_gmax - u_gmin));
        co += vec4(texCo*mask);
    }
    return co;
}

void main(void)
{
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
    float m_x = ((v_texCoord.x - u_cx) * (v_texCoord.x - u_cx)) / (u_hx * u_hx);
    float m_y = ((v_texCoord.y - u_cy) * (v_texCoord.y - u_cy)) / (u_hy * u_hy);
    float m_s = m_x + m_y;

    gl_FragColor = gradient(texColor, m_s);
}