#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float f_D;
uniform float f_S;

vec4 blur(vec2);

void main(void)
{
	vec4 col = blur(v_texCoord);
	gl_FragColor = col * v_fragmentColor;
}


vec4 blur(vec2 p)
{

    float samples[10] = {
                            -0.08,  
                            -0.05,  
                            -0.03,  
                            -0.02,  
                            -0.01,  
                            0.01,  
                            0.02,  
                            0.03,  
                            0.05,
                            0.08,
                    };
    float2 dir = vec2(0.5, 0.5) - p;
    float dist = length(dir);
    dir /= dist;
    vec4 color = texture2D(CC_Texture0, p);

    vec4 sum = color;

    for (int i = 0; i < 10; ++i)  
    {  
      sum += texture2D(CC_Texture0, p + dir * samples[i] * f_D);  
    } 
	float t = saturate(dist * f_S);
    sum /= 11.0;
    //color + (sum - color) * t
    return lerp(color, sum, t);
}